Index: src/tesselation.cpp
===================================================================
--- src/tesselation.cpp	(revision 3a0b3890298aafb5853dc67311a7ba037e2e94b4)
+++ src/tesselation.cpp	(revision 5ae39c416dba574777f0f8f68e7e7f9cacd96a25)
@@ -2502,5 +2715,5 @@
 
   if (LinesOnBoundary.empty()) {
-    Log() << Verbose(0) << "Error: There is no tesselation structure to compare the point with, please create one first.";
+    eLog() << Verbose(1) << "Error: There is no tesselation structure to compare the point with, please create one first.";
     return NULL;
   }
@@ -2510,9 +2723,9 @@
   // check whether closest point is "too close" :), then it's inside
   if (trianglePoints[0] == NULL) {
-    Log() << Verbose(2) << "Is the only point, no one else is closeby." << endl;
+    Log() << Verbose(0) << "Is the only point, no one else is closeby." << endl;
     return NULL;
   }
   if (trianglePoints[0]->node->DistanceSquared(x) < MYEPSILON) {
-    Log() << Verbose(3) << "Point is right on a tesselation point, no nearest triangle." << endl;
+    Log() << Verbose(1) << "Point is right on a tesselation point, no nearest triangle." << endl;
     PointMap::const_iterator PointRunner = PointsOnBoundary.find(trianglePoints[0]->nr);
     triangles = new list<BoundaryTriangleSet*>;
@@ -2533,10 +2746,12 @@
         triangles->unique();
       } else {
-        Log() << Verbose(1) << "ERROR: I cannot find a boundary point to the tessel point " << *trianglePoints[0] << "." << endl;
+        eLog() << Verbose(1) << "I cannot find a boundary point to the tessel point " << *trianglePoints[0] << "." << endl;
         return NULL;
       }
     }
   } else {
-    list<TesselPoint*> *connectedClosestPoints = GetCircleOfConnectedPoints(trianglePoints[0], x);
+    set<TesselPoint*> *connectedPoints = GetAllConnectedPoints(trianglePoints[0]);
+    TesselPointList *connectedClosestPoints = GetCircleOfSetOfPoints(connectedPoints, trianglePoints[0], x);
+    delete(connectedPoints);
     if (connectedClosestPoints != NULL) {
       trianglePoints[1] = connectedClosestPoints->front();
@@ -2544,24 +2759,24 @@
       for (int i=0;i<3;i++) {
         if (trianglePoints[i] == NULL) {
-          Log() << Verbose(1) << "ERROR: IsInnerPoint encounters serious error, point " << i << " not found." << endl;
+          eLog() << Verbose(1) << "IsInnerPoint encounters serious error, point " << i << " not found." << endl;
         }
-        //Log() << Verbose(2) << "List of triangle points:" << endl;
-        //Log() << Verbose(3) << *trianglePoints[i] << endl;
+        //Log() << Verbose(1) << "List of triangle points:" << endl;
+        //Log() << Verbose(2) << *trianglePoints[i] << endl;
       }
 
       triangles = FindTriangles(trianglePoints);
-      Log() << Verbose(2) << "List of possible triangles:" << endl;
+      Log() << Verbose(1) << "List of possible triangles:" << endl;
       for(list<BoundaryTriangleSet*>::iterator Runner = triangles->begin(); Runner != triangles->end(); Runner++)
-        Log() << Verbose(3) << **Runner << endl;
+        Log() << Verbose(2) << **Runner << endl;
 
       delete(connectedClosestPoints);
     } else {
       triangles = NULL;
-      Log() << Verbose(1) << "There is no circle of connected points!" << endl;
+      eLog() << Verbose(2) << "There is no circle of connected points!" << endl;
     }
   }
   
   if ((triangles == NULL) || (triangles->empty())) {
-    Log() << Verbose(0) << "ERROR: There is no nearest triangle. Please check the tesselation structure.";
+    eLog() << Verbose(1) << "There is no nearest triangle. Please check the tesselation structure.";
     delete(triangles);
     return NULL;
@@ -2578,4 +2793,5 @@
 class BoundaryTriangleSet * Tesselation::FindClosestTriangleToPoint(const Vector *x, const LinkedCell* LC) const
 {
+	Info FunctionInfo(__func__);
   class BoundaryTriangleSet *result = NULL;
   list<BoundaryTriangleSet*> *triangles = FindClosestTrianglesToPoint(x, LC);
@@ -2587,15 +2803,15 @@
   if (triangles->size() == 1) { // there is no degenerate case
     result = triangles->front();
-    Log() << Verbose(2) << "Normal Vector of this triangle is " << result->NormalVector << "." << endl;
+    Log() << Verbose(1) << "Normal Vector of this triangle is " << result->NormalVector << "." << endl;
   } else {
     result = triangles->front();
     result->GetCenter(&Center);
     Center.SubtractVector(x);
-    Log() << Verbose(2) << "Normal Vector of this front side is " << result->NormalVector << "." << endl;
+    Log() << Verbose(1) << "Normal Vector of this front side is " << result->NormalVector << "." << endl;
     if (Center.ScalarProduct(&result->NormalVector) < 0) {
       result = triangles->back();
-      Log() << Verbose(2) << "Normal Vector of this back side is " << result->NormalVector << "." << endl;
+      Log() << Verbose(1) << "Normal Vector of this back side is " << result->NormalVector << "." << endl;
       if (Center.ScalarProduct(&result->NormalVector) < 0) {
-        Log() << Verbose(1) << "ERROR: Front and back side yield NormalVector in wrong direction!" << endl;
+        eLog() << Verbose(1) << "Front and back side yield NormalVector in wrong direction!" << endl;
       }
     }
@@ -2614,4 +2830,5 @@
 bool Tesselation::IsInnerPoint(const Vector &Point, const LinkedCell* const LC) const
 {
+	Info FunctionInfo(__func__);
   class BoundaryTriangleSet *result = FindClosestTriangleToPoint(&Point, LC);
   Vector Center;
@@ -2623,7 +2840,7 @@
 
   result->GetCenter(&Center);
-  Log() << Verbose(3) << "INFO: Central point of the triangle is " << Center << "." << endl;
+  Log() << Verbose(2) << "INFO: Central point of the triangle is " << Center << "." << endl;
   Center.SubtractVector(&Point);
-  Log() << Verbose(3) << "INFO: Vector from center to point to test is " << Center << "." << endl;
+  Log() << Verbose(2) << "INFO: Vector from center to point to test is " << Center << "." << endl;
   if (Center.ScalarProduct(&result->NormalVector) > -MYEPSILON) {
     Log() << Verbose(1) << Point << " is an inner point." << endl;
@@ -2644,4 +2861,5 @@
 bool Tesselation::IsInnerPoint(const TesselPoint * const Point, const LinkedCell* const LC) const
 {
+	Info FunctionInfo(__func__);
   return IsInnerPoint(*(Point->node), LC);
 }
@@ -2655,10 +2873,9 @@
 set<TesselPoint*> * Tesselation::GetAllConnectedPoints(const TesselPoint* const Point) const
 {
+	Info FunctionInfo(__func__);
   set<TesselPoint*> *connectedPoints = new set<TesselPoint*>;
   class BoundaryPointSet *ReferencePoint = NULL;
   TesselPoint* current;
   bool takePoint = false;
-
-  Log() << Verbose(3) << "Begin of GetAllConnectedPoints" << endl;
 
   // find the respective boundary point
@@ -2667,5 +2884,5 @@
     ReferencePoint = PointRunner->second;
   } else {
-    Log() << Verbose(2) << "GetAllConnectedPoints() could not find the BoundaryPoint belonging to " << *Point << "." << endl;
+    eLog() << Verbose(2) << "GetAllConnectedPoints() could not find the BoundaryPoint belonging to " << *Point << "." << endl;
     ReferencePoint = NULL;
   }
@@ -2691,5 +2908,5 @@
 
    if (takePoint) {
-     Log() << Verbose(5) << "INFO: Endpoint " << *current << " of line " << *(findLines->second) << " is enlisted." << endl;
+     Log() << Verbose(1) << "INFO: Endpoint " << *current << " of line " << *(findLines->second) << " is enlisted." << endl;
      connectedPoints->insert(current);
    }
@@ -2699,9 +2916,8 @@
 
   if (connectedPoints->size() == 0) { // if have not found any points
-    Log() << Verbose(1) << "ERROR: We have not found any connected points to " << *Point<< "." << endl;
+    eLog() << Verbose(1) << "We have not found any connected points to " << *Point<< "." << endl;
     return NULL;
   }
 
-  Log() << Verbose(3) << "End of GetAllConnectedPoints" << endl;
   return connectedPoints;
 };
@@ -2715,12 +2931,13 @@
  *
  * @param *out output stream for debugging
+ * @param *SetOfNeighbours all points for which the angle should be calculated
  * @param *Point of which get all connected points
  * @param *Reference Reference vector for zero angle or NULL for no preference
  * @return list of the all points linked to the provided one
  */
-list<TesselPoint*> * Tesselation::GetCircleOfConnectedPoints(const TesselPoint* const Point, const Vector * const Reference) const
-{
+list<TesselPoint*> * Tesselation::GetCircleOfSetOfPoints(set<TesselPoint*> *SetOfNeighbours, const TesselPoint* const Point, const Vector * const Reference) const
+{
+	Info FunctionInfo(__func__);
   map<double, TesselPoint*> anglesOfPoints;
-  set<TesselPoint*> *connectedPoints = GetAllConnectedPoints(Point);
   list<TesselPoint*> *connectedCircle = new list<TesselPoint*>;
   Vector center;
@@ -2730,18 +2947,17 @@
   Vector helper;
 
-  if (connectedPoints == NULL) {
-    Log() << Verbose(2) << "Could not find any connected points!" << endl;
+  if (SetOfNeighbours == NULL) {
+    eLog() << Verbose(2) << "Could not find any connected points!" << endl;
     delete(connectedCircle);
     return NULL;
   }
-  Log() << Verbose(2) << "Begin of GetCircleOfConnectedPoints" << endl;
 
   // calculate central point
-  for (set<TesselPoint*>::const_iterator TesselRunner = connectedPoints->begin(); TesselRunner != connectedPoints->end(); TesselRunner++)
+  for (set<TesselPoint*>::const_iterator TesselRunner = SetOfNeighbours->begin(); TesselRunner != SetOfNeighbours->end(); TesselRunner++)
     center.AddVector((*TesselRunner)->node);
   //Log() << Verbose(0) << "Summed vectors " << center << "; number of points " << connectedPoints.size()
   //  << "; scale factor " << 1.0/connectedPoints.size();
-  center.Scale(1.0/connectedPoints->size());
-  Log() << Verbose(4) << "INFO: Calculated center of all circle points is " << center << "." << endl;
+  center.Scale(1.0/SetOfNeighbours->size());
+  Log() << Verbose(1) << "INFO: Calculated center of all circle points is " << center << "." << endl;
 
   // projection plane of the circle is at the closes Point and normal is pointing away from center of all circle points
@@ -2749,5 +2965,5 @@
   PlaneNormal.SubtractVector(&center);
   PlaneNormal.Normalize();
-  Log() << Verbose(4) << "INFO: Calculated plane normal of circle is " << PlaneNormal << "." << endl;
+  Log() << Verbose(1) << "INFO: Calculated plane normal of circle is " << PlaneNormal << "." << endl;
 
   // construct one orthogonal vector
@@ -2758,6 +2974,6 @@
   }
   if ((Reference == NULL) || (AngleZero.NormSquared() < MYEPSILON )) {
-    Log() << Verbose(4) << "Using alternatively " << *(*connectedPoints->begin())->node << " as angle 0 referencer." << endl;
-    AngleZero.CopyVector((*connectedPoints->begin())->node);
+    Log() << Verbose(1) << "Using alternatively " << *(*SetOfNeighbours->begin())->node << " as angle 0 referencer." << endl;
+    AngleZero.CopyVector((*SetOfNeighbours->begin())->node);
     AngleZero.SubtractVector(Point->node);
     AngleZero.ProjectOntoPlane(&PlaneNormal);
@@ -2767,18 +2983,18 @@
     }
   }
-  Log() << Verbose(4) << "INFO: Reference vector on this plane representing angle 0 is " << AngleZero << "." << endl;
+  Log() << Verbose(1) << "INFO: Reference vector on this plane representing angle 0 is " << AngleZero << "." << endl;
   if (AngleZero.NormSquared() > MYEPSILON)
     OrthogonalVector.MakeNormalVector(&PlaneNormal, &AngleZero);
   else
     OrthogonalVector.MakeNormalVector(&PlaneNormal);
-  Log() << Verbose(4) << "INFO: OrthogonalVector on plane is " << OrthogonalVector << "." << endl;
+  Log() << Verbose(1) << "INFO: OrthogonalVector on plane is " << OrthogonalVector << "." << endl;
 
   // go through all connected points and calculate angle
-  for (set<TesselPoint*>::iterator listRunner = connectedPoints->begin(); listRunner != connectedPoints->end(); listRunner++) {
+  for (set<TesselPoint*>::iterator listRunner = SetOfNeighbours->begin(); listRunner != SetOfNeighbours->end(); listRunner++) {
     helper.CopyVector((*listRunner)->node);
     helper.SubtractVector(Point->node);
     helper.ProjectOntoPlane(&PlaneNormal);
     double angle = GetAngle(helper, AngleZero, OrthogonalVector);
-    Log() << Verbose(3) << "INFO: Calculated angle is " << angle << " for point " << **listRunner << "." << endl;
+    Log() << Verbose(0) << "INFO: Calculated angle is " << angle << " for point " << **listRunner << "." << endl;
     anglesOfPoints.insert(pair<double, TesselPoint*>(angle, (*listRunner)));
   }
@@ -2787,8 +3003,4 @@
     connectedCircle->push_back(AngleRunner->second);
   }
-
-  delete(connectedPoints);
-
-  Log() << Verbose(2) << "End of GetCircleOfConnectedPoints" << endl;
 
   return connectedCircle;
@@ -2803,4 +3015,5 @@
 list<list<TesselPoint*> *> * Tesselation::GetPathsOfConnectedPoints(const TesselPoint* const Point) const
 {
+	Info FunctionInfo(__func__);
   map<double, TesselPoint*> anglesOfPoints;
   list<list<TesselPoint*> *> *ListOfPaths = new list<list<TesselPoint*> *>;
@@ -2822,5 +3035,5 @@
     ReferencePoint = PointRunner->second;
   } else {
-    Log() << Verbose(2) << "ERROR: GetPathOfConnectedPoints() could not find the BoundaryPoint belonging to " << *Point << "." << endl;
+    eLog() << Verbose(1) << "GetPathOfConnectedPoints() could not find the BoundaryPoint belonging to " << *Point << "." << endl;
     return NULL;
   }
@@ -2839,5 +3052,5 @@
       LineRunner = TouchedLine.find(runner->second);
       if (LineRunner == TouchedLine.end()) {
-        Log() << Verbose(2) << "ERROR: I could not find " << *runner->second << " in the touched list." << endl;
+        eLog() << Verbose(1) << "I could not find " << *runner->second << " in the touched list." << endl;
       } else if (!LineRunner->second) {
         LineRunner->second = true;
@@ -2847,13 +3060,13 @@
         StartLine = CurrentLine;
         CurrentPoint = CurrentLine->GetOtherEndpoint(ReferencePoint);
-        Log() << Verbose(3)<< "INFO: Beginning path retrieval at " << *CurrentPoint << " of line " << *CurrentLine << "." << endl;
+        Log() << Verbose(1)<< "INFO: Beginning path retrieval at " << *CurrentPoint << " of line " << *CurrentLine << "." << endl;
         do {
           // push current one
-          Log() << Verbose(3) << "INFO: Putting " << *CurrentPoint << " at end of path." << endl;
+          Log() << Verbose(1) << "INFO: Putting " << *CurrentPoint << " at end of path." << endl;
           connectedPath->push_back(CurrentPoint->node);
 
           // find next triangle
           for (TriangleMap::iterator Runner = CurrentLine->triangles.begin(); Runner != CurrentLine->triangles.end(); Runner++) {
-            Log() << Verbose(3) << "INFO: Inspecting triangle " << *Runner->second << "." << endl;
+            Log() << Verbose(1) << "INFO: Inspecting triangle " << *Runner->second << "." << endl;
             if ((Runner->second != triangle)) { // look for first triangle not equal to old one
               triangle = Runner->second;
@@ -2862,12 +3075,12 @@
                 if (!TriangleRunner->second) {
                   TriangleRunner->second = true;
-                  Log() << Verbose(3) << "INFO: Connecting triangle is " << *triangle << "." << endl;
+                  Log() << Verbose(1) << "INFO: Connecting triangle is " << *triangle << "." << endl;
                   break;
                 } else {
-                  Log() << Verbose(3) << "INFO: Skipping " << *triangle << ", as we have already visited it." << endl;
+                  Log() << Verbose(1) << "INFO: Skipping " << *triangle << ", as we have already visited it." << endl;
                   triangle = NULL;
                 }
               } else {
-                Log() << Verbose(2) << "ERROR: I could not find " << *triangle << " in the touched list." << endl;
+                eLog() << Verbose(1) << "I could not find " << *triangle << " in the touched list." << endl;
                 triangle = NULL;
               }
@@ -2880,5 +3093,5 @@
             if ((triangle->lines[i] != CurrentLine) && (triangle->lines[i]->ContainsBoundaryPoint(ReferencePoint))) { // not the current line and still containing Point
               CurrentLine = triangle->lines[i];
-              Log() << Verbose(3) << "INFO: Connecting line is " << *CurrentLine << "." << endl;
+              Log() << Verbose(1) << "INFO: Connecting line is " << *CurrentLine << "." << endl;
               break;
             }
@@ -2886,5 +3099,5 @@
           LineRunner = TouchedLine.find(CurrentLine);
           if (LineRunner == TouchedLine.end())
-            Log() << Verbose(2) << "ERROR: I could not find " << *CurrentLine << " in the touched list." << endl;
+            eLog() << Verbose(1) << "I could not find " << *CurrentLine << " in the touched list." << endl;
           else
             LineRunner->second = true;
@@ -2894,5 +3107,5 @@
         } while (CurrentLine != StartLine);
         // last point is missing, as it's on start line
-        Log() << Verbose(3) << "INFO: Putting " << *CurrentPoint << " at end of path." << endl;
+        Log() << Verbose(1) << "INFO: Putting " << *CurrentPoint << " at end of path." << endl;
         if (StartLine->GetOtherEndpoint(ReferencePoint)->node != connectedPath->back())
           connectedPath->push_back(StartLine->GetOtherEndpoint(ReferencePoint)->node);
@@ -2900,9 +3113,9 @@
         ListOfPaths->push_back(connectedPath);
       } else {
-        Log() << Verbose(3) << "INFO: Skipping " << *runner->second << ", as we have already visited it." << endl;
+        Log() << Verbose(1) << "INFO: Skipping " << *runner->second << ", as we have already visited it." << endl;
       }
     }
   } else {
-    Log() << Verbose(1) << "ERROR: There are no lines attached to " << *ReferencePoint << "." << endl;
+    eLog() << Verbose(1) << "There are no lines attached to " << *ReferencePoint << "." << endl;
   }
 
@@ -2918,4 +3131,5 @@
 list<list<TesselPoint*> *> * Tesselation::GetClosedPathsOfConnectedPoints(const TesselPoint* const Point) const
 {
+	Info FunctionInfo(__func__);
   list<list<TesselPoint*> *> *ListofPaths = GetPathsOfConnectedPoints(Point);
   list<list<TesselPoint*> *> *ListofClosedPaths = new list<list<TesselPoint*> *>;
@@ -2931,5 +3145,5 @@
     connectedPath = *ListRunner;
 
-    Log() << Verbose(2) << "INFO: Current path is " << connectedPath << "." << endl;
+    Log() << Verbose(1) << "INFO: Current path is " << connectedPath << "." << endl;
 
     // go through list, look for reappearance of starting Point and count
@@ -2941,5 +3155,5 @@
       if ((*CircleRunner == *CircleStart) && (CircleRunner != CircleStart)) { // is not the very first point
         // we have a closed circle from Marker to new Marker
-        Log() << Verbose(3) << count+1 << ". closed path consists of: ";
+        Log() << Verbose(1) << count+1 << ". closed path consists of: ";
         newPath = new list<TesselPoint*>;
         list<TesselPoint*>::iterator CircleSprinter = Marker;
@@ -2957,5 +3171,5 @@
     }
   }
-  Log() << Verbose(3) << "INFO: " << count << " closed additional path(s) have been created." << endl;
+  Log() << Verbose(1) << "INFO: " << count << " closed additional path(s) have been created." << endl;
 
   // delete list of paths
@@ -2979,8 +3193,9 @@
 set<BoundaryTriangleSet*> *Tesselation::GetAllTriangles(const BoundaryPointSet * const Point) const
 {
+	Info FunctionInfo(__func__);
   set<BoundaryTriangleSet*> *connectedTriangles = new set<BoundaryTriangleSet*>;
 
   if (Point == NULL) {
-    Log() << Verbose(1) << "ERROR: Point given is NULL." << endl;
+    eLog() << Verbose(1) << "Point given is NULL." << endl;
   } else {
     // go through its lines and insert all triangles
@@ -3014,8 +3229,8 @@
 
   if (point == NULL) {
-    Log() << Verbose(1) << "ERROR: Cannot remove the point " << point << ", it's NULL!" << endl;
+    eLog() << Verbose(1) << "Cannot remove the point " << point << ", it's NULL!" << endl;
     return 0.;
   } else
-    Log() << Verbose(2) << "Removing point " << *point << " from tesselated boundary ..." << endl;
+    Log() << Verbose(0) << "Removing point " << *point << " from tesselated boundary ..." << endl;
 
   // copy old location for the volume
@@ -3024,5 +3239,5 @@
   // get list of connected points
   if (point->lines.empty()) {
-    Log() << Verbose(1) << "ERROR: Cannot remove the point " << *point << ", it's connected to no lines!" << endl;
+    eLog() << Verbose(1) << "Cannot remove the point " << *point << ", it's connected to no lines!" << endl;
     return 0.;
   }
@@ -3047,5 +3262,5 @@
   NormalVector.Zero();
   for (map<class BoundaryTriangleSet *, int>::iterator Runner = Candidates.begin(); Runner != Candidates.end(); Runner++) {
-    Log() << Verbose(3) << "INFO: Removing triangle " << *(Runner->first) << "." << endl;
+    Log() << Verbose(1) << "INFO: Removing triangle " << *(Runner->first) << "." << endl;
     NormalVector.SubtractVector(&Runner->first->NormalVector); // has to point inward
     RemoveTesselationTriangle(Runner->first);
@@ -3077,5 +3292,5 @@
         smallestangle = 0.;
         for (MiddleNode = connectedPath->begin(); MiddleNode != connectedPath->end(); MiddleNode++) {
-          Log() << Verbose(3) << "INFO: MiddleNode is " << **MiddleNode << "." << endl;
+          Log() << Verbose(1) << "INFO: MiddleNode is " << **MiddleNode << "." << endl;
           // construct vectors to next and previous neighbour
           StartNode = MiddleNode;
@@ -3105,6 +3320,6 @@
         MiddleNode = EndNode;
         if (MiddleNode == connectedPath->end()) {
-          Log() << Verbose(1) << "CRITICAL: Could not find a smallest angle!" << endl;
-          exit(255);
+          eLog() << Verbose(0) << "CRITICAL: Could not find a smallest angle!" << endl;
+          performCriticalExit();
         }
         StartNode = MiddleNode;
@@ -3115,8 +3330,8 @@
         if (EndNode == connectedPath->end())
           EndNode = connectedPath->begin();
-        Log() << Verbose(4) << "INFO: StartNode is " << **StartNode << "." << endl;
-        Log() << Verbose(4) << "INFO: MiddleNode is " << **MiddleNode << "." << endl;
-        Log() << Verbose(4) << "INFO: EndNode is " << **EndNode << "." << endl;
-        Log() << Verbose(3) << "INFO: Attempting to create triangle " << (*StartNode)->Name << ", " << (*MiddleNode)->Name << " and " << (*EndNode)->Name << "." << endl;
+        Log() << Verbose(2) << "INFO: StartNode is " << **StartNode << "." << endl;
+        Log() << Verbose(2) << "INFO: MiddleNode is " << **MiddleNode << "." << endl;
+        Log() << Verbose(2) << "INFO: EndNode is " << **EndNode << "." << endl;
+        Log() << Verbose(1) << "INFO: Attempting to create triangle " << (*StartNode)->Name << ", " << (*MiddleNode)->Name << " and " << (*EndNode)->Name << "." << endl;
         TriangleCandidates[0] = *StartNode;
         TriangleCandidates[1] = *MiddleNode;
@@ -3124,5 +3339,5 @@
         triangle = GetPresentTriangle(TriangleCandidates);
         if (triangle != NULL) {
-          Log() << Verbose(1) << "WARNING: New triangle already present, skipping!" << endl;
+          eLog() << Verbose(0) << "New triangle already present, skipping!" << endl;
           StartNode++;
           MiddleNode++;
@@ -3136,9 +3351,9 @@
           continue;
         }
-        Log() << Verbose(5) << "Adding new triangle points."<< endl;
+        Log() << Verbose(3) << "Adding new triangle points."<< endl;
         AddTesselationPoint(*StartNode, 0);
         AddTesselationPoint(*MiddleNode, 1);
         AddTesselationPoint(*EndNode, 2);
-        Log() << Verbose(5) << "Adding new triangle lines."<< endl;
+        Log() << Verbose(3) << "Adding new triangle lines."<< endl;
         AddTesselationLine(TPS[0], TPS[1], 0);
         AddTesselationLine(TPS[0], TPS[2], 1);
@@ -3155,5 +3370,5 @@
         // prepare nodes for next triangle
         StartNode = EndNode;
-        Log() << Verbose(4) << "Removing " << **MiddleNode << " from closed path, remaining points: " << connectedPath->size() << "." << endl;
+        Log() << Verbose(2) << "Removing " << **MiddleNode << " from closed path, remaining points: " << connectedPath->size() << "." << endl;
         connectedPath->remove(*MiddleNode); // remove the middle node (it is surrounded by triangles)
         if (connectedPath->size() == 2) { // we are done
@@ -3162,6 +3377,6 @@
           break;
         } else if (connectedPath->size() < 2) { // something's gone wrong!
-          Log() << Verbose(1) << "CRITICAL: There are only two endpoints left!" << endl;
-          exit(255);
+          eLog() << Verbose(0) << "CRITICAL: There are only two endpoints left!" << endl;
+          performCriticalExit();
         } else {
           MiddleNode = StartNode;
@@ -3191,5 +3406,5 @@
           if (maxgain != 0) {
             volume += maxgain;
-            Log() << Verbose(3) << "Flipping baseline with highest volume" << **Candidate << "." << endl;
+            Log() << Verbose(1) << "Flipping baseline with highest volume" << **Candidate << "." << endl;
             OtherBase = FlipBaseline(*Candidate);
             NewLines.erase(Candidate);
@@ -3202,5 +3417,5 @@
       delete(connectedPath);
     }
-    Log() << Verbose(1) << count << " triangles were created." << endl;
+    Log() << Verbose(0) << count << " triangles were created." << endl;
   } else {
     while (!ListOfClosedPaths->empty()) {
@@ -3210,9 +3425,9 @@
       delete(connectedPath);
     }
-    Log() << Verbose(1) << "No need to create any triangles." << endl;
+    Log() << Verbose(0) << "No need to create any triangles." << endl;
   }
   delete(ListOfClosedPaths);
 
-  Log() << Verbose(1) << "Removed volume is " << volume << "." << endl;
+  Log() << Verbose(0) << "Removed volume is " << volume << "." << endl;
 
   return volume;
@@ -3231,4 +3446,5 @@
 list<BoundaryTriangleSet*> *Tesselation::FindTriangles(const TesselPoint* const Points[3]) const
 {
+	Info FunctionInfo(__func__);
   list<BoundaryTriangleSet*> *result = new list<BoundaryTriangleSet*>;
   LineMap::const_iterator FindLine;
@@ -3279,4 +3495,5 @@
 map<int, int> * Tesselation::FindAllDegeneratedLines()
 {
+	Info FunctionInfo(__func__);
   map<int, class BoundaryLineSet *> AllLines;
   map<int, int> * DegeneratedLines = new map<int, int>;
@@ -3284,5 +3501,5 @@
   // sanity check
   if (LinesOnBoundary.empty()) {
-    Log() << Verbose(1) << "Warning: FindAllDegeneratedTriangles() was called without any tesselation structure.";
+    eLog() << Verbose(2) << "FindAllDegeneratedTriangles() was called without any tesselation structure.";
     return DegeneratedLines;
   }
@@ -3300,8 +3517,8 @@
   AllLines.clear();
 
-  Log() << Verbose(1) << "FindAllDegeneratedLines() found " << DegeneratedLines->size() << " lines." << endl;
+  Log() << Verbose(0) << "FindAllDegeneratedLines() found " << DegeneratedLines->size() << " lines." << endl;
   map<int,int>::iterator it;
   for (it = DegeneratedLines->begin(); it != DegeneratedLines->end(); it++)
-      Log() << Verbose(2) << (*it).first << " => " << (*it).second << endl;
+      Log() << Verbose(0) << (*it).first << " => " << (*it).second << endl;
 
   return DegeneratedLines;
@@ -3316,4 +3533,5 @@
 map<int, int> * Tesselation::FindAllDegeneratedTriangles()
 {
+	Info FunctionInfo(__func__);
   map<int, int> * DegeneratedLines = FindAllDegeneratedLines();
   map<int, int> * DegeneratedTriangles = new map<int, int>;
@@ -3343,8 +3561,8 @@
   delete(DegeneratedLines);
 
-  Log() << Verbose(1) << "FindAllDegeneratedTriangles() found " << DegeneratedTriangles->size() << " triangles:" << endl;
+  Log() << Verbose(0) << "FindAllDegeneratedTriangles() found " << DegeneratedTriangles->size() << " triangles:" << endl;
   map<int,int>::iterator it;
   for (it = DegeneratedTriangles->begin(); it != DegeneratedTriangles->end(); it++)
-      Log() << Verbose(2) << (*it).first << " => " << (*it).second << endl;
+      Log() << Verbose(0) << (*it).first << " => " << (*it).second << endl;
 
   return DegeneratedTriangles;
@@ -3357,10 +3575,9 @@
 void Tesselation::RemoveDegeneratedTriangles()
 {
+	Info FunctionInfo(__func__);
   map<int, int> * DegeneratedTriangles = FindAllDegeneratedTriangles();
   TriangleMap::iterator finder;
   BoundaryTriangleSet *triangle = NULL, *partnerTriangle = NULL;
   int count  = 0;
-
-  Log() << Verbose(1) << "Begin of RemoveDegeneratedTriangles" << endl;
 
   for (map<int, int>::iterator TriangleKeyRunner = DegeneratedTriangles->begin();
@@ -3421,11 +3638,11 @@
       // erase the pair
       count += (int) DegeneratedTriangles->erase(triangle->Nr);
-      Log() << Verbose(1) << "RemoveDegeneratedTriangles() removes triangle " << *triangle << "." << endl;
+      Log() << Verbose(0) << "RemoveDegeneratedTriangles() removes triangle " << *triangle << "." << endl;
       RemoveTesselationTriangle(triangle);
       count += (int) DegeneratedTriangles->erase(partnerTriangle->Nr);
-      Log() << Verbose(1) << "RemoveDegeneratedTriangles() removes triangle " << *partnerTriangle << "." << endl;
+      Log() << Verbose(0) << "RemoveDegeneratedTriangles() removes triangle " << *partnerTriangle << "." << endl;
       RemoveTesselationTriangle(partnerTriangle);
     } else {
-      Log() << Verbose(1) << "RemoveDegeneratedTriangles() does not remove triangle " << *triangle
+      Log() << Verbose(0) << "RemoveDegeneratedTriangles() does not remove triangle " << *triangle
         << " and its partner " << *partnerTriangle << " because it is essential for at"
         << " least one of the endpoints to be kept in the tesselation structure." << endl;
@@ -3433,7 +3650,8 @@
   }
   delete(DegeneratedTriangles);
-
-  Log() << Verbose(1) << "RemoveDegeneratedTriangles() removed " << count << " triangles:" << endl;
-  Log() << Verbose(1) << "End of RemoveDegeneratedTriangles" << endl;
+  if (count > 0)
+    LastTriangle = NULL;
+
+  Log() << Verbose(0) << "RemoveDegeneratedTriangles() removed " << count << " triangles:" << endl;
 }
 
@@ -3448,6 +3666,5 @@
 void Tesselation::AddBoundaryPointByDegeneratedTriangle(class TesselPoint *point, LinkedCell *LC)
 {
-  Log() << Verbose(2) << "Begin of AddBoundaryPointByDegeneratedTriangle" << endl;
-
+	Info FunctionInfo(__func__);
   // find nearest boundary point
   class TesselPoint *BackupPoint = NULL;
@@ -3462,8 +3679,8 @@
     NearestBoundaryPoint = PointRunner->second;
   } else {
-    Log() << Verbose(1) << "ERROR: I cannot find the boundary point." << endl;
+    eLog() << Verbose(1) << "I cannot find the boundary point." << endl;
     return;
   }
-  Log() << Verbose(2) << "Nearest point on boundary is " << NearestPoint->Name << "." << endl;
+  Log() << Verbose(0) << "Nearest point on boundary is " << NearestPoint->Name << "." << endl;
 
   // go through its lines and find the best one to split
@@ -3498,9 +3715,9 @@
 
   // create new triangle to connect point (connects automatically with the missing spot of the chosen line)
-  Log() << Verbose(5) << "Adding new triangle points."<< endl;
+  Log() << Verbose(2) << "Adding new triangle points."<< endl;
   AddTesselationPoint((BestLine->endpoints[0]->node), 0);
   AddTesselationPoint((BestLine->endpoints[1]->node), 1);
   AddTesselationPoint(point, 2);
-  Log() << Verbose(5) << "Adding new triangle lines."<< endl;
+  Log() << Verbose(2) << "Adding new triangle lines."<< endl;
   AddTesselationLine(TPS[0], TPS[1], 0);
   AddTesselationLine(TPS[0], TPS[2], 1);
